public inbox for development@lists.ipfire.org
 help / color / mirror / Atom feed
From: Michael Tremer <michael.tremer@ipfire.org>
To: development@lists.ipfire.org
Subject: [PATCH] make.sh: Add command to find dependencies
Date: Wed, 13 May 2020 11:52:59 +0100	[thread overview]
Message-ID: <20200513105259.28975-1-michael.tremer@ipfire.org> (raw)
In-Reply-To: <112CD7FD-306C-4D86-9C7B-1809A11B0D63@ipfire.org>

[-- Attachment #1: Type: text/plain, Size: 1616 bytes --]

Signed-off-by: Michael Tremer <michael.tremer(a)ipfire.org>
---
 make.sh                 |  6 +++++-
 tools/find-dependencies | 32 ++++++++++++++++++++++++++++++++
 2 files changed, 37 insertions(+), 1 deletion(-)
 create mode 100755 tools/find-dependencies

diff --git a/make.sh b/make.sh
index 78c4edc90..4acce807f 100755
--- a/make.sh
+++ b/make.sh
@@ -1993,8 +1993,12 @@ lang)
 update-contributors)
 	update_contributors
 	;;
+find-dependencies)
+	shift
+	exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
+	;;
 *)
-	echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors}"
+	echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies}"
 	cat doc/make.sh-usage
 	;;
 esac
diff --git a/tools/find-dependencies b/tools/find-dependencies
new file mode 100755
index 000000000..25e6cddea
--- /dev/null
+++ b/tools/find-dependencies
@@ -0,0 +1,32 @@
+#!/bin/bash
+
+main() {
+	if [ $# -lt 2 ]; then
+		echo "${0}: Usage: PATH LIBRARY ..."
+		return 2
+	fi
+
+	local root="${1}"
+	shift
+
+	if [ ! -d "${root}" ]; then
+		echo "${0}: ${root}: No such file or directory"
+		return 1
+	fi
+
+	local libraries="$@"
+
+	# Build the regex filter
+	local filter="(${libraries[*]// /|})"
+
+	local file
+	for file in $(find "${root}" -xdev -type f -executable); do
+		if readelf -d "${file}" 2>/dev/null | grep -qE "NEEDED.*\[${filter}\]$"; then
+			echo "${file}"
+		fi
+	done
+
+	return 0
+}
+
+main "$@" || exit $?
-- 
2.12.2


  reply	other threads:[~2020-05-13 10:52 UTC|newest]

Thread overview: 10+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-05-01 10:54 [PATCH] nettle: Update to 3.6 Matthias Fischer
2020-05-01 13:17 ` Michael Tremer
2020-05-02  8:53   ` Matthias Fischer
2020-05-04 14:32     ` Michael Tremer
2020-05-13 10:52       ` Michael Tremer [this message]
2020-05-13 10:55       ` Michael Tremer
2020-05-13 21:37         ` Matthias Fischer
2020-05-14 10:43           ` Michael Tremer
2020-05-14 11:35             ` Matthias Fischer
2020-05-14 11:37               ` Michael Tremer

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200513105259.28975-1-michael.tremer@ipfire.org \
    --to=michael.tremer@ipfire.org \
    --cc=development@lists.ipfire.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox